/* extension.js
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * SPDX-License-Identifier: GPL-2.0-or-later
 */

/* exported init enable disable */

const Lang = imports.lang;

const ExtensionUtils = imports.misc.extensionUtils;

const Me = ExtensionUtils.getCurrentExtension();

const Convenience = Me.imports.convenience;

const PANEL_MANAGER_CHILDRENS = [
    'hotCorners',
    'activities',
    'dateMenu',
    'keyboard',
    'systemMenu',
    'dropDownArrow',
    'dash',
    'showDesktop',
    'favorites',
    'places',
    'applications',
    'recycleBin',
];

const PanelManager = new Lang.Class({
    Name: 'PanelManager',

    _init() {
        this._childrens = [];
        PANEL_MANAGER_CHILDRENS.forEach(child => {
//            try {
                this._childrens.push(Me.imports[child].getExtension());
//            } catch (e) {}
        });
    },

    destroy() {
        while (this._childrens.length > 0) {
            let child = this._childrens.pop();
            child.destroy();
            child = null;
        }
        this._childrens = null;
    }
});

function init(metadata) {
    Convenience.initTranslations();
}

let _extension;

function enable() {
    _extension = new PanelManager();
}

function disable() {
    _extension.destroy();
    _extension = null;
}
